unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, LCLType, StdCtrls, Types, Math,

  {$ifdef arm}
  dglOpenGLSE,
  {$else}
  dglOpenGL,
  {$endif}

  Mesh, MyMath, Rad, Zylinder, Stange;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    Timer1: TTimer;
    ToggleBoxDirection: TToggleBox;
    ToggleBoxTimer: TToggleBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure OpenGLControl1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure OpenGLControl1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToggleBoxDirectionClick(Sender: TObject);
    procedure ToggleBoxTimerChange(Sender: TObject);














  public
    BildPara: record
      zoom, x, y, xalt, yalt: single;
    end;

    Mesh: TMesh;


    PleuelSchwinge3, PleuelSchwinge4: TStange;

    TreibRad: record
      Richtung: (fwd, rwd);
      Radius, AufkeilWinkel: single;
      Rad: TRad;
      GegenKurbelRadius, ExzenterRadius: single;
    end;

    Schubstange: record
      ZylinderAbstand: single;
      Schubstange, Treibstange, KolbenStange: TStange;
      Kolben: TKolben
    end;

    SchiebeZylinder: record
      Top: single;
      Kolben: TKolben;
      SchieberStange: TStange;
    end;

    SchwingeGestaenge: record
      HaengeEisen_xy: TPointF;
      SchwingenStange, Schwinge, SchieberSchubstange, HaengeEisen: TStange;
    end;

    Voreilhebel: record
      Lenkeransatz_Height: single;
      Lenkeransatz,
      Lenkstange, StangeSchieber, StangeSchieberTop: TStange;
      KnieHbl: TKniehebel;
    end;

    //    Abstand: TPointf;
    RadAbstand, speed, winkel: single;
    procedure BackGround;
  end;

var
  Form1: TForm1;

implementation


{ TForm1 }

procedure TForm1.BackGround;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();

  glBegin(GL_QUADS);
  glColor3f(0.4, 0.2, 0.3);
  glVertex3f(-1.0, -1.0, 0.999);
  glColor3f(0.45, 0.25, 0.3);
  glVertex3f(+1.0, -1.0, 0.999);
  glColor3f(0.4, 0.25, 0.53);
  glVertex3f(+1.0, +1.0, 0.999);
  glColor3f(0.45, 0.2, 0.35);
  glVertex3f(-1.0, +1.0, 0.999);
  glEnd();

  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if TreibRad.Richtung = rwd then begin
    winkel += speed;
    if winkel > 360 then begin
      winkel -= 360;
    end;
  end else begin
    winkel -= speed;
    if winkel < 0 then begin
      winkel += 360;
    end;
  end;

  OpenGLControl1.Repaint;
end;

procedure TForm1.ToggleBoxDirectionClick(Sender: TObject);
begin
  if ToggleBoxDirection.Checked then begin
    TreibRad.Richtung := rwd;
    SchwingeGestaenge.HaengeEisen_xy.y := SchiebeZylinder.Top+SchwingeGestaenge.HaengeEisen.Laenge+300;
//    SchwingeGestaenge.HaengeEisen_xy.y := 1000;
  end else begin
    TreibRad.Richtung := fwd;
    SchwingeGestaenge.HaengeEisen_xy.y := SchiebeZylinder.Top+SchwingeGestaenge.HaengeEisen.Laenge-300;
//    SchwingeGestaenge.HaengeEisen_xy.y := 400;
  end;
end;

procedure TForm1.ToggleBoxTimerChange(Sender: TObject);
begin
  Timer1.Enabled := ToggleBoxTimer.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  ReadExtensions;
  ReadImplementationProperties;
  OpenGLControl1.MakeCurrent;

  with BildPara do begin
    zoom := 0.001;
  end;


  with TreibRad do begin
    //    Richtung := fwd;
    Radius := 500.0;
    ExzenterRadius := Radius * 0.65;
    GegenKurbelRadius := Radius * 0.4;
    AufkeilWinkel := -90.0;

    Rad := TRad.Create(Radius);
    RadAbstand := Radius * 2.4;
  end;

  SchiebeZylinder.Top := 300.0;

  with Schubstange do begin
    Schubstange := TStange.Create(TreibRad.Radius / 8, RadAbstand, vec3(1.0, 0.2, 0.2));
    Treibstange := TStange.Create(TreibRad.Radius / 8, RadAbstand * 1.53, vec3(1.0, 0.2, 0.2));
    KolbenStange := TStange.Create(TreibRad.Radius / 8, TreibRad.ExzenterRadius * 2, vec3(1.0, 0.2, 0.2));
    Kolben := TKolben.Create(TreibRad.ExzenterRadius * 2);
    ZylinderAbstand := Treibstange.Laenge;
  end;

  with SchwingeGestaenge do begin
    with HaengeEisen_xy do begin
      x := TreibRad.Radius * 2 - 300;
    end;
    SchwingenStange := TStange.Create(TreibRad.Radius / 12, TreibRad.Radius * 2 * 1.2, vec3(0.2, 1.0, 0.2));
    Schwinge := TStange.Create(TreibRad.Radius / 6, TreibRad.Radius, vec3(0.2, 0.2, 1.0));

    SchieberSchubstange := TStange.Create(TreibRad.Radius / 12, RadAbstand * 1.0 + 300, vec3(1.0, 0.2, 0.2));
    HaengeEisen := TStange.Create(TreibRad.Radius / 12, TreibRad.Radius, vec3(1.0, 0.2, 0.2));
    ToggleBoxDirectionClick(Sender);
  end;

  with Voreilhebel do begin
    Lenkeransatz_Height := 200;
    StangeSchieber := TStange.Create(TreibRad.Radius / 12, SchiebeZylinder.Top + Lenkeransatz_Height / 0.6, vec3(1.0, 0.2, 0.2));
    Lenkstange := TStange.Create(TreibRad.Radius / 12, StangeSchieber.Laenge / 2, vec3(1.0, 0.2, 0.2));
    Lenkeransatz := TStange.Create(TreibRad.Radius / 12, Lenkeransatz_Height, vec3(1.0, 0.2, 0.2));
    StangeSchieberTop := TStange.Create(TreibRad.Radius / 12, 100, vec3(1.0, 0.2, 0.2));
  end;


  Mesh := TMesh.Create;

  with SchiebeZylinder do begin
    Kolben := TKolben.Create(TreibRad.GegenKurbelRadius * 2);
    SchieberStange := TStange.Create(TreibRad.Radius / 12, TreibRad.GegenKurbelRadius * 2, vec3(1.0, 0.2, 0.2));
  end;

  PleuelSchwinge3 := TStange.Create(TreibRad.Radius / 24, TreibRad.Radius * 2 / 1.0, vec3(1.0, 0.2, 0.2));
  PleuelSchwinge4 := TStange.Create(TreibRad.Radius / 24, TreibRad.Radius * 2 / 1.3, vec3(1.0, 0.2, 0.2));
  speed := 3.10344;

  Trigo.Grad := True;
  Timer1.Enabled := True;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var
  ExzenterSchubstange_xy, ExzenterSchwinge_xy: TPointf;
  SchieberHubPos, KreuzKopf_x, p2: single;
  Schwinge0, Schwinge1: TSchwinge;

begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  BackGround;

  // --- Bremsklötze

  with TreibRad do begin
    glTranslatef(-RadAbstand * 2, 0.0, 0.0);
    Mesh.Arc(Radius * 1.2, Radius * 1.4, 0, 60); // deutet eine Schwinge1 an
    glColor3f(1, 1, 1);
    Mesh.Arc(Radius * 1.2, Radius * 1.4, 90, 180.0); // deutet eine Schwinge1 an
    glColor3f(1, 0.1, 1);
    if winkel < 180.0 then begin
      glRotatef(winkel / 10, 0.0, 0.0, 1.0);
    end else begin
      glRotatef(180.0 / 10 - (winkel / 10 - 180.0 / 10), 0.0, 0.0, 1.0);
    end;
    Mesh.Arc(Radius * 1.4, Radius * 1.6, -30, 30); // deutet eine Schwinge1 an

    glLoadIdentity();
  end;

  // --- Treibrad


  with TreibRad do begin
    Rad.Draw(winkel);
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);

    glLoadIdentity();
  end;


  with Schubstange do begin
    glTranslatef(0, 0, -0.03);

    // --- Schubstange

    ExzenterSchubstange_xy := Trigo.Alpha_c_To_xy(winkel, TreibRad.ExzenterRadius);

    glTranslatef(ExzenterSchubstange_xy.x, ExzenterSchubstange_xy.y, 0);

    glPushMatrix;
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Schubstange.Draw;
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Schubstange.Draw;
    glPopMatrix;

    // --- Treibstange

    glRotatef(-Trigo.a_c_To_Alpha(ExzenterSchubstange_xy.y, Treibstange.Laenge), 0.0, 0.0, 1.0);
    Treibstange.Draw;
    glLoadIdentity();


    // --- Kolben

    KreuzKopf_x := sqrt(sqr(Treibstange.Laenge) - sqr(ExzenterSchubstange_xy.y)) + ExzenterSchubstange_xy.x;

    glTranslatef(KreuzKopf_x, 0.0, 0.0);
    KolbenStange.Draw;
    glLoadIdentity();

    glTranslatef(ZylinderAbstand + KolbenStange.Laenge, 0.0, 0.0);

    SchieberHubPos := KreuzKopf_x - Treibstange.Laenge + TreibRad.ExzenterRadius;
    Kolben.Draw(SchieberHubPos);
    glLoadIdentity();

    // Kolben Schieber

    if TreibRad.Richtung = fwd then begin
      ExzenterSchwinge_xy := Trigo.Alpha_c_To_xy(winkel + TreibRad.AufkeilWinkel, TreibRad.GegenKurbelRadius);
    end else begin
      ExzenterSchwinge_xy := Trigo.Alpha_c_To_xy(winkel - TreibRad.AufkeilWinkel, TreibRad.GegenKurbelRadius);
    end;
    p2 := sqrt(sqr(Treibstange.Laenge) - sqr(ExzenterSchwinge_xy.y)) + ExzenterSchwinge_xy.x;
    SchieberHubPos := p2 - Treibstange.Laenge + TreibRad.ExzenterRadius - (TreibRad.ExzenterRadius - TreibRad.GegenKurbelRadius);

    p2 := p2 + SchiebeZylinder.SchieberStange.Laenge;

    glTranslatef(ZylinderAbstand + KolbenStange.Laenge, SchiebeZylinder.Top, 0.0);
    SchiebeZylinder.Kolben.Draw(SchieberHubPos);

    glLoadIdentity();
  end;

  // --- Voreilhebel

  with Voreilhebel do begin
    KnieHbl.SetParam(PointF(KreuzKopf_x, -Lenkeransatz_Height), PointF(p2, SchiebeZylinder.Top), Lenkstange.Laenge, StangeSchieber.Laenge, True);
    glTranslatef(KreuzKopf_x, 0, 0);

    glPushMatrix;
    glRotatef(-90, 0.0, 0.0, 0.1);
    Lenkeransatz.Draw;
    glPopMatrix;

    glTranslatef(0.0, -Lenkeransatz_Height, 0.0);


    glRotatef(KnieHbl.Stange1_W, 0.0, 0.0, 0.1);
    Lenkstange.Draw;
    glLoadIdentity();

    glTranslatef(p2, SchiebeZylinder.Top, 0);
    glRotatef(KnieHbl.Stange2_W, 0.0, 0.0, 0.1);
    StangeSchieber.Draw;
    glTranslatef(-StangeSchieberTop.Laenge, 0.0, 0.0);
    StangeSchieberTop.Draw;
    glLoadIdentity();
  end;


  // --- SchwingeGestaenge ---

  with SchwingeGestaenge do begin

    Schwinge0.SetParam(Voreilhebel.KnieHbl.Stange2_W + 180, Voreilhebel.StangeSchieberTop.Laenge,
      PointF(-p2 + HaengeEisen_xy.x, -SchiebeZylinder.Top + HaengeEisen_xy.y),
      SchieberSchubstange.Laenge, HaengeEisen.Laenge);


    // Pleuel

    glPushMatrix;

    glTranslatef(Schwinge0.RadExzenter.x + p2, Schwinge0.RadExzenter.y + SchiebeZylinder.Top, -0.2);
    glRotatef(Schwinge0.Pleuel_W, 0.0, 0.0, 1.0);
    SchieberSchubstange.Draw;

    glPopMatrix;
    with HaengeEisen_xy do begin
      glTranslatef(x, y, -0.2);
    end;

    glRotatef(Schwinge0.Schwinge_W, 0.0, 0.0, 1.0);
    HaengeEisen.Draw;
    glLoadIdentity();

  end;

  // --- SchiebeZylinder


  glTranslatef(p2, SchiebeZylinder.Top, -0.2);
  SchiebeZylinder.SchieberStange.Draw;
  glLoadIdentity();

  // --- Schwinge ---

  with SchwingeGestaenge do begin
    Schwinge1.SetParam(winkel + TreibRad.AufkeilWinkel, TreibRad.GegenKurbelRadius, PointF(RadAbstand, SchiebeZylinder.Top),
      SchwingenStange.Laenge, Schwinge.Laenge, True);


    // Schwingenstange

    glTranslatef(Schwinge1.RadExzenter.x, Schwinge1.RadExzenter.y, -0.2);
    glRotatef(Schwinge1.Pleuel_W, 0.0, 0.0, 1.0);
    SchwingenStange.Draw;
    glLoadIdentity();

    // Schwinge

    glTranslatef(RadAbstand, SchiebeZylinder.Top, -0.2);
    glRotatef(Schwinge1.Schwinge_W, 0.0, 0.0, 1.0);
    Schwinge.Draw;
    glRotatef(180, 0.0, 0.0, 1.0);
    Schwinge.Draw;
    glLoadIdentity();

  end;

  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  with TreibRad do begin
    Rad.Free;
  end;

  with  SchiebeZylinder do begin
    Kolben.Free;
    SchieberStange.Free;
  end;

  with Schubstange do begin
    Schubstange.Free;
    Treibstange.Free;
    KolbenStange.Free;
    Kolben.Free;
  end;

  with SchwingeGestaenge do begin
    SchieberSchubstange.Free;
    HaengeEisen.Free;
    SchwingenStange.Free;
    Schwinge.Free;
  end;

  with Voreilhebel do begin
    Lenkeransatz.Free;
    Lenkstange.Free;
    StangeSchieber.Free;
    StangeSchieberTop.Free;
  end;

  Mesh.Free;
  PleuelSchwinge3.Free;
  PleuelSchwinge4.Free;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);

    with BildPara do begin
      glTranslatef(BildPara.x, BildPara.y, 0.0);
      glScalef(zoom, zoom, zoom);
    end;
  end;
end;


procedure TForm1.OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
const
  Step = 0.0050;
begin
  if Shift = [ssLeft] then begin
    BildPara.x += (X - BildPara.xalt) * Step;
    BildPara.y += -(Y - BildPara.yalt) * Step;
    OpenGLControl1Resize(Sender);
  end;
  BildPara.xalt := x;
  BildPara.yalt := y;
end;

procedure TForm1.OpenGLControl1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: boolean);
begin
  BildPara.zoom *= 1.05;
  OpenGLControl1Resize(Sender);
end;

procedure TForm1.OpenGLControl1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: boolean);
begin
  BildPara.zoom /= 1.05;
  OpenGLControl1Resize(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

initialization

  {$I unit1.lrs}

end.
